<?php
/********************************************************************************
* GlobalAnnouncements.php                                                       *
* ----------------------------------------------------------------------------- *
* This shows the announcements that have been made.                             *
*********************************************************************************
* Software version:               Global Announcements 0.1                      *
* Software by:                    Juan "JayBachatero" Hernandez                 *
* Copyright (c) 2006 by:          Juan "JayBachatero" Hernandez                 *
* Contact:                        Jay@JayBachatero.com                          *
* Website:                        JayBachatero.com                              *
* ============================================================================= *
* This mod is free software; you may redistribute it and/or modify it as long   *
* as you credit me for the original mod. This mod is distributed in the hope    *
* that it is and will be useful, but WITHOUT ANY WARRANTIES; without even any   *
* implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
*                                                                               *
* All SMF copyrights are still in effect. Anything not mine is theirs. Enjoy!   *
* Some code found in here is copy written code by SMF, therefore it can not be  *
* redistributed without official consent from myself or SMF.                    *
********************************************************************************/

if (!defined('SMF'))
	die('Hacking attemp...');

function GlobalAnnouncements()
{
	// Load the template and language files.
	loadTemplate('GlobalAnnouncements');
	loadLanguage('GlobalAnnouncementsAdmin');

	//Lets make sure we limit to these subActions so that some fool doesn't come and try to mess things up ;).
	$subActions = array(
		'main' => 'mainGA',
		'print' => 'printGlobalAnnouncement',
	);

	//Set a default subAction.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'main';
	$context['sub_action'] = $_REQUEST['sa'];

	//Call the function.
	$subActions[$_REQUEST['sa']]();
}

function mainGA()
{
	global $context, $user_info, $db_prefix, $memberContext, $txt, $scripturl, $ID_MEMBER;

	// Some idiots now-a-days think its funny to add [] at the end of ?x so they make it look like this. ?x[]=1.  Sorry buddy tough luck.
	if (is_array($_REQUEST['id']) || !is_numeric($_REQUEST['id']))
		fatal_lang_error('ga_error_query_array');

	// Hahahahahahahahaha.  I like to move it, move it...
	if (isset($_REQUEST['id']) && $_REQUEST['id'] == '0')
		die('
			<object width="425" height="350">
				<param name="movie" value="http://www.youtube.com/v/4fflvz6JZNQ"></param>
				<embed src="http://www.youtube.com/v/4fflvz6JZNQ" type="application/x-shockwave-flash" width="425" height="350"></embed>
			</object>
			<br /><a href="javascript:history.go(-1)">Back</a>'
		);

	//Check is an id is set.
	if (!isset($_REQUEST['id']) || empty($_REQUEST['id']))
		fatal_lang_error('ga_error_no_id');

	//Load the boards that they can see.
	$can_see_boards = db_query("
		SELECT gab.ID_BOARD
		FROM {$db_prefix}boards AS b
			LEFT JOIN {$db_prefix}global_announcements_boards AS gab ON (gab.ID_BOARD = b.ID_BOARD)
		WHERE $user_info[query_see_board]
			AND gab.ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);
	$numRows = mysql_num_rows($can_see_boards);
	mysql_free_result($can_see_boards);

	// Check to see if they can see atleast one board.
	if ($numRows == 0)
	{
		//Check to see what is the ID_BOARD.
		$check_id_board = db_query("
			SELECT ID_BOARD
			FROM {$db_prefix}global_announcements_boards
			WHERE ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);
		$selectID = mysql_fetch_row($check_id_board);
		mysql_free_result($check_id_board);

		// IF ID_BOARD is equal to 0 that means that it's an all boards announcement.  Lets check if they can see one board.
		if ($selectID[0] == 0)
		{
			//Since we have 0 as all boards check to see if they can see any board at all.
			$check_can_see = db_query("
				SELECT b.ID_BOARD
				FROM {$db_prefix}boards AS b
				WHERE $user_info[query_see_board]
				LIMIT 1", __FILE__, __LINE__);
			$check_can_see_numRows = mysql_num_rows($check_can_see);
			mysql_free_result($check_can_see);

			//Check if result is 1
			if ($check_can_see_numRows == 1)
				$can_see = true;
			else
				$can_see = false;
		}
		else
			$can_see = false;
	}

	// Ok if $numRows is equal to 0 and $can_see is false kick them out.
	if ($numRows == 0 && $can_see == false)
		fatal_lang_error('ga_error_not_allowed');

	// Select the steak.
	$selectGA = db_query("
		SELECT
			ga.ID_GA, ga.time, ga.modifiedTime, ga.modifiedName, ga.icon, ga.subject,
			ga.body, ga.countViews, ga.numViews, ga.ID_MEMBER
		FROM {$db_prefix}global_announcements AS ga
		WHERE ga.ID_GA = '$_REQUEST[id]'
			" . (!$context['user']['is_admin'] ? "AND enabled = '1'" : "") . "
		LIMIT 1", __FILE__, __LINE__);

	// Check if a valid id was entred.
	$count = mysql_num_rows($selectGA);

	if ($count == 0)
		fatal_lang_error('ga_error_no_id');

	// Set $globalAnnouncement array();
	$globalAnnouncement = array();

	// Now that we got up to here insert into array
	while ($row = mysql_fetch_array($selectGA))
	{
		$globalAnnouncement = array(
			'id' => $row['ID_GA'],
			'id_member' => $row['ID_MEMBER'],
			'time' => timeformat($row['time']),
			'modifiedTime' => empty($row['modifiedTime']) ? '' : timeformat($row['modifiedTime']),
			'modifiedName' => $row['modifiedName'],
			'icon' => empty($row['icon']) ? 'xx' : $row['icon'],
			'subject' => $row['subject'],
			'body' => $row['body'],
			'countViews' => $row['countViews'],
			'numViews' => $row['numViews'],
			'delete' => $scripturl . '?action=globalAnnouncementsAdmin;sa=delete;id=' .$row['ID_GA'],
			'edit' => $scripturl . '?action=globalAnnouncementsAdmin;sa=edit;id=' .$row['ID_GA'],
			'href' => $scripturl . '?action=globalAnnouncements;id=' .$row['ID_GA'],
		);
	}
	mysql_free_result($selectGA);

	// Load member data.
	loadMemberData($globalAnnouncement['id_member']);
	loadMemberContext($globalAnnouncement['id_member']);

	// Parse the bbc
	$globalAnnouncement['body'] = parse_bbc($globalAnnouncement['body']);

	// Prepare the body and subject.
	censorText($globalAnnouncement['body']);
	censorText($globalAnnouncement['subject']);

	// Build the link tree.
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=globalAnnouncements;id=' .$globalAnnouncement['id'],
		'name' => $globalAnnouncement['subject'],
		'extra_before' => '<b>' .$txt['ga']. '</b>&nbsp;>&nbsp;',
	);

	// Count the views.
	if ($globalAnnouncement['countViews'] == 1)
	{
		countViews($globalAnnouncement['id']);
		$globalAnnouncement['numViews']++;
	}

	// Set the $context['globalAnnouncement']
	$memberContext[$globalAnnouncement['id_member']]['can_view_profile'] = allowedTo('profile_view_any') || ($globalAnnouncement['id_member'] == $ID_MEMBER && allowedTo('profile_view_own'));
	$context['globalAnnouncement'] = $globalAnnouncement;
	$context['globalAnnouncement']['member'] = $memberContext[$globalAnnouncement['id_member']];

	// Set the title.
	$context['page_title'] = $globalAnnouncement['subject'];

	// Load the template.
	$context['sub_template'] = 'main';

}

function countViews($ID_GA)
{
	global $db_prefix;

	if (isset($ID_GA))
	{
		db_query("
			UPDATE {$db_prefix}global_announcements
			SET numViews = numViews+1
			WHERE ID_GA = '$ID_GA'", __FILE__, __LINE__);
	}
}

function printGlobalAnnouncement()
{
	global $scripturl, $db_prefix, $context, $user_info;

	// Some idiots now-a-days think its funny to add [] at the end of ?x so they make it look like this. ?x[]=1.  Sorry buddy tough luck.
	if (is_array($_REQUEST['id']))
		fatal_lang_error('ga_error_query_array');

	// Hahahahahahahahaha.  I like to move it, move it...
	if (isset($_REQUEST['id']) && $_REQUEST['id'] == 0)
		die('
			<object width="425" height="350">
				<param name="movie" value="http://www.youtube.com/v/4fflvz6JZNQ"></param>
				<embed src="http://www.youtube.com/v/4fflvz6JZNQ" type="application/x-shockwave-flash" width="425" height="350"></embed>
			</object>
			<br /><a href="javascript:history.go(-1)">Back</a>'
		);

	// Check is an id is set.
	if (!isset($_REQUEST['id']) || empty($_REQUEST['id']))
		fatal_lang_error('ga_error_no_id');

	// Once again check if they can see this.
	//Load the boards that they can see.
	$can_see_boards = db_query("
		SELECT gab.ID_BOARD
		FROM {$db_prefix}boards AS b
			LEFT JOIN {$db_prefix}global_announcements_boards AS gab ON (gab.ID_BOARD = b.ID_BOARD)
		WHERE $user_info[query_see_board]
			AND gab.ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);
	$numRows = mysql_num_rows($can_see_boards);
	mysql_free_result($can_see_boards);

	// Check to see if they can see atleast one board.
	if ($numRows == 0)
	{
		//Check to see what is the ID_BOARD.
		$check_id_board = db_query("
			SELECT ID_BOARD
			FROM {$db_prefix}global_announcements_boards
			WHERE ID_GA = '$_REQUEST[id]'", __FILE__, __LINE__);
		$selectID = mysql_fetch_row($check_id_board);
		mysql_free_result($check_id_board);

		// IF ID_BOARD is equal to 0 that means that it's an all boards announcement.  Lets check if they can see one board.
		if ($selectID[0] == 0)
		{
			//Since we have 0 as all boards check to see if they can see any board at all.
			$check_can_see = db_query("
				SELECT b.ID_BOARD
				FROM {$db_prefix}boards AS b
				WHERE $user_info[query_see_board]
				LIMIT 1", __FILE__, __LINE__);
			$check_can_see_numRows = mysql_num_rows($check_can_see);
			mysql_free_result($check_can_see);

			//Check if result is 1
			if ($check_can_see_numRows == 1)
				$can_see = true;
			else
				$can_see = false;
		}
		else
			$can_see = false;
	}

	// Ok if $numRows is equal to 0 and $can_see is false kick them out.
	if ($numRows == 0 && $can_see == false)
		fatal_lang_error('ga_error_not_allowed');

	// Select the data.
	$request = db_query("
		SELECT
			ga.time, ga.subject, ga.body, mem.realName
		FROM {$db_prefix}global_announcements AS ga
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = ga.ID_MEMBER)
		WHERE ID_GA = '$_REQUEST[id]'
		LIMIT 1", __FILE__, __LINE__);

	// Check if a valid id was entred.
	$count = mysql_num_rows($request);

	if ($count == 0)
		fatal_lang_error('ga_error_no_id');

	// The data.
	$row = mysql_fetch_array($request);

	// Set the context stuff.
	$context['subject'] = $row['subject'];
	$context['body'] = parse_bbc($row['body'], 'print');
	$context['time'] = timeformat($row['time']);
	$context['member'] = $row['realName'];

	// Free the results
	mysql_free_result($request);

	// Load the template.
	$context['template_layers'] = array();
	$context['sub_template'] = 'print';
}
?>
