<id>
jaybachatero:ga
</id>

<version>
1.0
</version>

<edit file>
$boarddir/index.php
</edit file>
<search for>
		'findmember' => array('Subs-Auth.php', 'JSMembers'),
</search for>
<add after>
		'globalAnnouncementsAdmin' => array('GlobalAnnouncementsAdmin.php', 'GlobalAnnouncementsAdmin'),
		'globalAnnouncements' => array('GlobalAnnouncements.php', 'GlobalAnnouncements'),
</add after>

<edit file>
$sourcedir/MessageIndex.php
</edit file>
<search for>
	$context['no_topic_listing'] = !empty($context['boards']) && empty($context['topics']) && !$context['can_post_new'];
</search for>
<add after>
	//Check to see if Global Announcements are enabled.
	if (isset($modSettings['global_announcements_enable']) && $modSettings['global_announcements_enable'] == 1)
	{
		//Load the Global Announcements.
		$selectGA = db_query("
			SELECT
				ga.ID_GA, ga.ID_MEMBER, ga.time, ga.icon, ga.subject, ga.numViews, ga.enabled,
				gab.ID_BOARD, m.realName
			FROM {$db_prefix}global_announcements AS ga
				LEFT JOIN {$db_prefix}global_announcements_boards AS gab ON (ga.ID_GA = gab.ID_GA)
				LEFT JOIN {$db_prefix}members AS m ON (ga.ID_MEMBER = m.ID_MEMBER)
			WHERE gab.ID_BOARD = '$board' OR gab.ID_board = '0'
				" .(!$context['user']['is_admin'] ? "AND enabled = '1'" : ""). "
			ORDER BY gaOrder ASC,
				" . (isset($modSettings['global_announcements_sort_by'], $modSettings['global_announcements_sort_direction'])
					? $modSettings['global_announcements_sort_by'] . ' ' . $modSettings['global_announcements_sort_direction']
					: "time DESC"), __FILE__, __LINE__);

		//Set $globalAnnouncements array.
		$globalAnnouncements = array();

		//Loop through the results.
		while ($row = mysql_fetch_array($selectGA))
		{
			// Cencor the text  Hope this fixes UTF-8 issues
			censorText($row['subject']);

			$globalAnnouncements[] = array(
				'member' => array(
					'id' => $row['ID_MEMBER'],
					'name' => $row['realName'],
					'link' => '<a href="' .$scripturl. '?action=profile;u=' .$row['ID_MEMBER']. '">' .$row['realName']. '</a>',
				),
				'ga' => array(
					'id' => $row['ID_GA'],
					'time' => timeformat($row['time']),
					'icon' => empty($row['icon']) ? 'xx' : $row['icon'],
					'subject' => censorText($row['subject']),
					'views' => $row['numViews'],
					'href' => $scripturl . '?action=globalAnnouncements;id=' .$row['ID_GA'],
					'enabled' => $row['enabled'],
				),
			);
		}
		mysql_free_result($selectGA);

		// Set $context['globalAnnouncements'].
		$context['globalAnnouncements'] = $globalAnnouncements;
	}
</add after>

<edit file>
$sourcedir/ManageNews.php
</edit file>
<search for>
		$context['sub_template'] = 'email_members_compose';
	}
</search for>
<add after>
	// Global Announcements $context['default_messages'] and $context['default_message'] overwrite.
	if (isset($_SESSION['ga_subject'], $_SESSION['ga_message']))
	{
		$context['default_subject'] = $context['forum_name'] . ': ' . $_SESSION['ga_subject'];
		$context['default_message'] = $_SESSION['ga_link'] . "\n\n" . $_SESSION['ga_message'] . "\n\n" . $txt[130];
	}
</add after>
<search for>
		$context['sub_template'] = 'email_members_send';
		return;
	}
</search for>
<add after>
	// Unset the ga sessions
	if (isset($_SESSION['ga_subject'], $_SESSION['ga_message']))
	{
		unset($_SESSION['ga_subject']);
		unset($_SESSION['ga_message']);
		unset($_SESSION['ga_link']);
	}
</add after>

<edit file>
$sourcedir/Who.php
</edit file>
<search for>
		'viewmembers' => array('moderate_forum'),
</search for>
<add after>
		'globalAnnouncementsAdmin' => array('global_announcements_admin'),
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>
<search for>
	$context['in_maintenance'] = !empty($maintenance);
</search for>
<add before>
	$context['allow_admin'] .= allowedTo(array('global_announcements_admin'));
</add before>
<search for>
		if (!empty($modSettings['modlog_enabled']))
			$context['admin_areas']['maintenance']['areas']['view_moderation_log'] = '<a href="' . $scripturl . '?action=modlog">' . $txt['modlog_view'] . '</a>';
	}
</search for>
<add after>

	//A new mods section for the Global Announcements.
	if ((isset($modSettings['admin_areas_other']) && $modSettings['admin_areas_other'] == 1) && allowedTo('global_announcements_admin'))
	{
		$context['admin_areas']['other']['areas']['ga_admin'] = '<a href="' . $scripturl . '?action=globalAnnouncementsAdmin">' . $txt['global_announcements_admin'] . '</a>';
	}
	elseif (!isset($modSettings['admin_areas_other']) || (isset($modSettings['admin_areas_other']) && $modSettings['admin_areas_other'] == 0) && allowedTo('global_announcements_admin'))
	{
		$context['admin_areas']['ga_admin'] = array(
			'title' =>  $txt['global_announcements_mods'],
			'areas' => array(
				'ga_admin' => '<a href="' . $scripturl . '?action=globalAnnouncementsAdmin">' . $txt['global_announcements_admin'] . '</a>',
			),
		);
	}
</add after>

<edit file>
$sourcedir/ManagePermissions.php
</edit file>
<search for>
		'profile_title_any',
	));
</search for>
<replace>
		'profile_title_any',
		'global_announcements_admin',
	));
</replace>
<search for>
				'edit_news' => false,
			),
</search for>
<replace>
				'edit_news' => false,
				'global_announcements_admin' => false,
			),
</replace>
<search for>
		'send_mail',
	);
</search for>
<replace>
		'send_mail',
		'global_announcements_admin',
	);
</replace>

<edit file>
$themedir/index.template.php
</edit file>
<search for>
	if ($context['current_action'] == 'search2')
		$current_action = 'search';
</search for>
<add before>
	if ($context['current_action'] == 'globalAnnouncementsAdmin')
		$current_action = 'admin';
</add before>

<edit file>
$themedir/MessageIndex.template.php
</edit file>
<search for>
	// Create the button set...
	$normal_buttons = array(
</search for>
<add before>
	// Global Announcements...
	if (isset($context['globalAnnouncements']) && count($context['globalAnnouncements']) != 0)
	{
		echo '
		<div class="tborder" ', $context['browser']['needs_size_fix'] && !$context['browser']['is_ie6'] ? 'style="width: 100%;"' : '', '>
			<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
				<tr>
					<td colspan="7" class="titlebg">Global Announcements</td>
				<tr>
				<tr>
					<td class="catbg3" width="9%" colspan="2"></td>
					<td class="catbg3">', $txt[70], '</td>
					<td class="catbg3" width="14%">', $txt[109], '</td>
					<td class="catbg3" width="4%" align="center">', $txt[110], '</td>
					<td class="catbg3" width="4%" align="center">', $txt[301], '</td>
					<td class="catbg3" width="22%">Time</td>
				</tr>';

			// Loop through the Global Announcements
			foreach ($context['globalAnnouncements'] as $globalAnnouncement)
			{
				echo '
				<tr class="windowbg2">
					<td align="center">
						<img src="', $settings['images_url'], '/post/' .$globalAnnouncement['ga']['icon']. '.gif" alt="" />
					</td>
					<td align="center">
						<img src="', $settings['images_url'], '/post/exclamation.gif" alt="" />
					</td>
					<td ' ,$globalAnnouncement['ga']['enabled'] == 0 ? 'style="background-color: #e9e9e9; color: #8d8d8d;"' : 'class="windowbg"', '>
						<a href="' ,$globalAnnouncement['ga']['href'], '" >', $globalAnnouncement['ga']['subject'], '</a>
					</td>
					<td>
						', $globalAnnouncement['member']['link'], '
					</td>
					<td align="center" class="windowbg">
						--
					</td>
					<td align="center" class="windowbg">
						', $globalAnnouncement['ga']['views'], '
					</td>
					<td>
						', $globalAnnouncement['ga']['time'], '
					</td>
				</tr>';
			}

		echo '
			</table>
		</div><br />';
	}
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>
<search for>
?>
</search for>
<add before>
//Global Announcements adminIndex text strings.
$txt['global_announcements_admin'] = 'Global Announcements';
$txt['global_announcements_mods'] = 'Mods';
$txt['whoallow_globalAnnouncementsAdmin'] = 'Managing the <a href="' . $scripturl . '?action=globalAnnouncementsAdmin">Global Announcements</a>.';
$txt['whoall_globalAnnouncements'] = 'Viewing a Global Announcement';
</add before>

<edit file>
$languagedir/Help.english.php
</edit file>
<search for>
?>
</search for>
<add before>
$helptxt['global_announcements_enable'] = 'This will override the local enable/disable setting for Global Announcements and enable it or disable it';
</add before>

<edit file>
$languagedir/ManagePermissions.english.php
</edit file>
<search for>
?>
</search for>
<add before>

//Global Announcements permissions.
$txt['permissionname_global_announcements_admin'] = 'Manage Global Announcements';
$txt['permissionhelp_global_announcements_admin'] = 'If you enable this permission for this membergroup they will be allowed to add, edit, delete Global Announcements';
</add>

<edit file>
$languagedir/Errors.english.php
</edit file>
<search for>
$txt['cannot_calendar_view'] = 'Sorry, but you are not allowed to view the calendar.';
</search for>
<add after>
$txt['cannot_global_announcements_admin'] = 'Sorry, you\'re not allowed to admin the Global Announcements area.';
</add after>
